<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        Default images and guidance on art by RJsaurus - https://twitter.com/deeposaurus
        BakkesWebApi by gboddin - Heavily modified and extended by SimpleAOB
            - Now available at: https://gitlab.com/bakkesplugins/sos/sos-plugin
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SOS - Rocket League OBS Browser Source Overlay</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
</head>
<body>
    <div class="page-container">
        <div class="waiting-for-websocket">
            <div class="technical-difficulties hidden"></div>
            <div class="text">
                Waiting for Websocket Server to connect...
            </div>
        </div>
        <div class="header">
            <div class="vote-bars">
                <table>
                    <tr>
                        <td class="left-bar" style="width: 50%">
                            <div class="wrapper">
                                <div class="left-edge">
                                    <svg xmlns="http://www.w3.org/2000/svg" width="40px" height="146px">
                                        <rect fill-rule="evenodd" class="bar-edge-color" fill="#0090d3" width="40" height="146"/>
                                    </svg>
                                </div>
                                <div class="color-bg" style="background: #0090d3">
                                    <div class="logo"><img></div>
                                    <div class="text">
                                        <span class="percent-text">50%</span><br><span class="command"></span>
                                    </div>
                                </div>
                            </div>
                        </td>
                        <td class="right-bar" style="width: 50%">
                            <div class="wrapper">
                                <div class="right-edge">
                                    <svg xmlns="http://www.w3.org/2000/svg" width="40px" height="146px">
                                        <rect fill-rule="evenodd" class="bar-edge-color" fill="#f26522" width="40" height="146"/>
                                    </svg>
                                </div>

                                <div class="color-bg" style="background: #f26522">
                                    <div class="logo"><img></div>
                                    <div class="text">
                                        <span class="percent-text">50%</span><br><span class="command"></span>
                                    </div>
                                </div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    <script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
    <script>${require('../out/js/base.js')}</script>
    <script>
        //!!! Register the websocket listeners before attempting to connect
        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
            WsSubscribers.send("cb", "first_connect", {
                'name': 'TickerVoting',
                'version': ${require('../version.txt')}
            });
            setInterval(function () {
                WsSubscribers.send("cb", "heartbeat", "heartbeat");
            }, 1000);
        });

        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
        });

        WsSubscribers.subscribe("ws", "error", function() {
            $(".waiting-for-websocket .text").text("[002] There has been an error with the Rocket League connection. Please stand by");
            $(".waiting-for-websocket").removeClass("hidden");
        });

        WsSubscribers.subscribe("ws", "close", function() {
            $(".waiting-for-websocket .text").text("[004] Connection to Rocket League has gone away. Please stand by");
            $(".waiting-for-websocket, .technical-difficulties").removeClass("hidden");
        });

        WsSubscribers.init(49322, false, [
            "game:update_tick",
            "cb:heartbeat"
        ]);
    </script>
    <script>
        let teamMap = ${require('../../team_logos/map.json')};
        WsSubscribers.subscribe("sos", "up_next_teams_update", (d) => {
            let leftLower = d.left.name.toLowerCase();
            let rightLower = d.right.name.toLowerCase();

            if (teamMap.hasOwnProperty(leftLower)) {
                let teamLeft = teamMap[leftLower];
                $('.left-bar .logo img').attr('src', `../team_logos/${teamLeft.logo}`);
                $('.left-bar .bar-edge-color').attr('fill', teamLeft.background);
                $('.left-bar .color-bg').css('background', teamLeft.background);
                $('.left-bar .percent-text').css('color', teamLeft.black_text ? 'black' : 'white');
            } else {
                $('.left-bar .logo img').attr('src', `../team_logos/DEFAULT.png`);
                $('.left-bar .bar-edge-color').attr('fill', '#0090d3');
                $('.left-bar .color-bg').css('background', '#0090d3');
                $('.left-bar .percent-text').css('color', 'white');
            }

            if (teamMap.hasOwnProperty(rightLower)) {
                let teamRight = teamMap[rightLower];
                $('.right-bar .logo img').attr('src', `../team_logos/${teamRight.logo}`);
                $('.right-bar .bar-edge-color').attr('fill', teamRight.background);
                $('.right-bar .color-bg').css('background', teamRight.background);
                $('.right-bar .percent-text').css('color', teamRight.black_text ? 'black' : 'white');
            } else {
                $('.right-bar .logo img').attr('src', `../team_logos/DEFAULT.png`);
                $('.right-bar .bar-edge-color').attr('fill', '#f26522');
                $('.right-bar .color-bg').css('background', '#f26522');
                $('.right-bar .percent-text').css('color', 'white');
            }
        });
        WsSubscribers.subscribe("sos", "twitch_votes_update", d => {
            $(".vote-bars .left-bar .command").text(d.left.command);
            $(".vote-bars .right-bar .command").text(d.right.command);

            let widthPercent = d.left.percent * 100;
            if (widthPercent > 80) {
                widthPercent = 80;
            } else if (widthPercent < 20) {
                widthPercent = 20;
            }

            $('.vote-bars .left-bar').css('width', widthPercent+'%');
            $('.vote-bars .left-bar .color-bg  .percent-text').text((d.left.percent*100)+'%');
            $('.vote-bars .right-bar .color-bg .percent-text').text((d.right.percent*100)+'%');
        });
    </script>
    <script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>